﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;
using System.Threading;

namespace HelloWorldPlugin2.Models
{
    public class MovieList
    {
        private static List<Movie> _movies;
        static MovieList()
        {
            _movies = new List<Movie>();
            _movies.Add(new Movie() { Id = IdGenerator.GetId(), Name = "M1", Rating = 5 });
            _movies.Add(new Movie() { Id = IdGenerator.GetId(), Name = "M2", Rating = 5 });
            _movies.Add(new Movie() { Id = IdGenerator.GetId(), Name = "M3", Rating = 4 });
        }

        public List<Movie> GetMovies()
        {
            return _movies;
        }
    }

    public static class IdGenerator
    {
        private static int _id = 0;

        public static int GetId()
        {
            return Interlocked.Increment(ref _id);
        }
    }

    [MetadataType(typeof(MovieMD))]
    public class Movie
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public int Rating { get; set; }

        public static Movie NewMovie()
        {
            return new Movie() { Id = IdGenerator.GetId() };
        }

        public class MovieMD
        {
            [Required(ErrorMessage = "名称不能为空。")]
            [DisplayName("名称")]
            public string Name { get; set; }
            [Range(0, Int32.MaxValue, ErrorMessage = "评价必须大于等于0。")]
            [DisplayName("名称")]
            public int Rating { get; set; }
        }
    }
}